// Template file v5.15r (12/18/01)
////////////////////////////////////////////////////////////////////////
// File: menu.wdl
//		WDL prefabs for simple game menus
////////////////////////////////////////////////////////////////////////
//



////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////

ifndef MENU_DEFS;
 sound  menu_click <click.wav>;	// menu select sound
 define menu_font standard_font;	// menu font
 bmap button_low,<black.pcx>,0,0,64,10;// menu item background
 bmap button_hi,<white.pcx>,0,0,64,10;	// menu selected item background
 bmap yesno_back,<black.pcx>,0,0,64,24;// yes/no panel background
 bmap yesno_low,<black.pcx>,0,0,28,10;	// yes/no button background
 bmap yesno_hi,<white.pcx>,0,0,28,10;	// yes/no selected button background
 bmap arrow,<arrow.pcx>;// mouse pointer
 define YES_OFFS_X,2;	// offsets for yes/no buttons to panel
 define NO_OFFS_X,34;
 define YESNO_OFFS_Y,12;
endif;	// MENU_DEFS

ifndef MENU_DEFS2;
 define CONSOLE_MODE_2;	// console line don't disappear after [ENTER]
 define INFO_NAME,"stat";
 define SAVE_NAME,"game";
endif;
//////////////////////////////////////////////////////////
// legacy skills to be preserved on score loading & level change
SKILL sound_vol = { type GLOBAL; VAL 100; }
SKILL midi_vol = { type GLOBAL; VAL 50; }

//////////////////////////////////////////////////////////
var menu_pos[2] = 10, 10;	// position of menu on screen
var menu_dist[2] = 4, 12;	// distance between buttons
var menu_offs[2] = 2,  1; 	// offset text to button below
var menu_max = 7; 			// max items per menu

var yesno_pos[2] = 10, 10; // position of yes/no panel
var yesno_offs[2] = 2,  2;	// offset text to panel

//////////////////////////////////////////////////////////
// Texts and messages appearing in the menu
string new_game_str,"New";
string load_game_str,"Load";
string save_game_str,"Save";
string quit_game_str,"Quit";
string options_str,"Options";
string help_str,"Help";
string resume_str,"Back";

string yes_str,"Yes";
string no_str," No";

string quit_yesno,"  Quit?";

string ok_str,"OK";
string wait_str,"Please wait...";
string save_error,"MALFUNCTION... can't save game";
string load_error,"MALFUNCTION... save before loading!";

string helptxt_str,
"ESC - Menu
F1  - Help
F2  - Quicksave
F3  - Quickload
F4  - Multiplayer message
F5  - Toggle resolution
F6  - screenshot
F7  - Toggle person mode
F11 - Toggle gamma
F12 - Toggle sound/music
F10 - exit";

//////////////////////////////////////////////////////////
// a lot of default strings, actions and pointers
// which are used for the items of the menu

var menu_cursor = 0;  // determines which item is selected

// strings for the names of the five games to save and load
string name1_str,"         ";
string name2_str,"         ";
string name3_str,"         ";
string name4_str,"         ";
string name5_str,"         ";

string* mystring;

// pointers to the actions to execute for each of the 7 menu items
action* menu_do1;
action* menu_do2;
action* menu_do3;
action* menu_do4;
action* menu_do5;
action* menu_do6;
action* menu_do7;

// pointers to save and restore any actions that were
// previously assigned to menu keys
action* old_menu_esc;
action* old_help_esc;
action* old_yesno_esc;
action* old_menu_enter;
action* old_yesno_enter;
action* old_cud;
action* old_cuu;
action* old_cul;
action* old_cur;
action* old_f1;

// Actions which are really performed if clicking one of the 7 menu items.
// The menu has to disappear before the action is executed
function _b1() { _menu_clear(); menu_do1(); }
function _b2() { _menu_clear(); menu_do2(); }
function _b3() { _menu_clear(); menu_do3(); }
function _b4() { _menu_clear(); menu_do4(); }
function _b5() { _menu_clear(); menu_do5(); }
function _b6() { _menu_clear(); menu_do6(); }
function _b7() { _menu_clear(); menu_do7(); }

function _buttonclick() { play_sound menu_click,40; }

// Texts on the menu item buttons
text menu_txt1 { layer 11; font menu_font; string empty_str; }
text menu_txt2 { layer 11; font menu_font; string empty_str; }
text menu_txt3 { layer 11; font menu_font; string empty_str; }
text menu_txt4 { layer 11; font menu_font; string empty_str; }
text menu_txt5 { layer 11; font menu_font; string empty_str; }
text menu_txt6 { layer 11; font menu_font; string empty_str; }
text menu_txt7 { layer 11; font menu_font; string empty_str; }

// The items of which the menu really consists.
// Each item is a panel with a single button.
panel menu_pan1
{
	layer 10; flags refresh,transparent;
	button 0,0,button_hi,button_low,button_hi,_b1,null,_buttonclick;
}
panel menu_pan2
{
	layer 10; flags refresh,transparent;
	button 0,0,button_hi,button_low,button_hi,_b2,null,_buttonclick;
}
panel menu_pan3
{
	layer 10; flags refresh,transparent;
	button 0,0,button_hi,button_low,button_hi,_b3,null,_buttonclick;
}
panel menu_pan4
{
	layer 10; flags refresh,transparent;
	button 0,0,button_hi,button_low,button_hi,_b4,null,_buttonclick;
}
panel menu_pan5
{
	layer 10; flags refresh,transparent;
	button 0,0,button_hi,button_low,button_hi,_b5,null,_buttonclick;
}
panel menu_pan6
{
	layer 10; flags refresh,transparent;
	button 0,0,button_hi,button_low,button_hi,_b6,null,_buttonclick;
}
panel menu_pan7
{
	layer 10; flags refresh,transparent;
	button 0,0,button_hi,button_low,button_hi,_b7,null,_buttonclick;
}

panel menu_select
{
	layer 10.5; bmap button_hi; flags refresh,transparent;
}

/////////////////////////////////////////////////////////////////////
// This action initializes the menu
// This just makes all menu items - buttons and texts above - visible on screen.
function _menu_visible()
{
	if(menu_max >= 1)
	{
		menu_pan1.visible = ON;
		menu_txt1.visible = ON;
	}
	if(menu_max >= 2)
	{
		menu_pan2.visible = ON;
		menu_txt2.visible = ON;
	}
	if(menu_max >= 3)
	{
		menu_pan3.visible = ON;
		menu_txt3.visible = ON;
	}
	if(menu_max >= 4)
	{
		menu_pan4.visible = ON;
		menu_txt4.visible = ON;
	}
	if(menu_max >= 5)
	{
		menu_pan5.visible = ON;
		menu_txt5.visible = ON;
	}
	if(menu_max >= 6)
	{
		menu_pan6.visible = ON;
		menu_txt6.visible = ON;
	}
	if(menu_max >= 7)
	{
		menu_pan7.visible = ON;
		menu_txt7.visible = ON;
	}
	freeze_mode = 1;	// when the menu is on screen, the game freezes
	menu_cursor = 1;	// place to first item
}


// This just lets all menu items disappear again
function _menu_hide()
{
	menu_pan1.visible = OFF;
	menu_txt1.visible = OFF;
	menu_pan2.visible = OFF;
	menu_txt2.visible = OFF;
	menu_pan3.visible = OFF;
	menu_txt3.visible = OFF;
	menu_pan4.visible = OFF;
	menu_txt4.visible = OFF;
	menu_pan5.visible = OFF;
	menu_txt5.visible = OFF;
	menu_pan6.visible = OFF;
	menu_txt6.visible = OFF;
	menu_pan7.visible = OFF;
	menu_txt7.visible = OFF;
	menu_select.visible = OFF;
}

// This quits the menu, restores old key actions, and continues the game
function _menu_clear()
{
	if(menu_cursor > 0)
	{
		_menu_hide();
		on_esc = old_menu_esc;
		on_cuu = old_cuu;
		on_cud = old_cud;
		on_enter = old_menu_enter;
		freeze_mode = 0;
		menu_cursor = 0;
	}
}

// One item up
function _menu_up()
{
	menu_cursor -= 1;
	_menu_set();
}

// One item down
function _menu_down()
{
	menu_cursor += 1;
	_menu_set();
}

// Highlights the selected menu item, onto which the menu cursor is placed
function _menu_set()
{
	// cursor highlight has no effect in mouse mode
	if(mouse_mode >= 1) { menu_select.visible = OFF; return; }

	// restrict the menu cursor to valid values
	if(menu_cursor < 1) { menu_cursor = menu_max; }
	if(menu_cursor > menu_max) { menu_cursor = 1; }

	// set the highlight panel onto the selected item, and make it visible
	menu_select.pos_x = menu_pos.x + (menu_cursor-1) * menu_dist.x;
	menu_select.pos_y = menu_pos.y + (menu_cursor-1) * menu_dist.y;
	menu_select.visible = ON;
	_buttonclick();
}

// Desc: exceutes the action of the selected menu item
function _menu_exec()
{
	// if alt or ctrl was pressed, don't execute the menu but the old action
	if(KEY_ALT || KEY_CTRL) { old_menu_enter(); return; }

	// now ececute the item action, dependent on the menu cursor position
	play_sound(menu_click,60);
	if(menu_cursor == 1) { _b1(); return; }
	if(menu_cursor == 2) { _b2(); return; }
	if(menu_cursor == 3) { _b3(); return; }
	if(menu_cursor == 4) { _b4(); return; }
	if(menu_cursor == 5) { _b5(); return; }
	if(menu_cursor == 6) { _b6(); return; }
	if(menu_cursor == 7) { _b7(); return; }
}

function menu_show()
{
	_yesno_hide();	// if a yesno panel was active, hide it

	// First, set all button panels to their correct positions
	menu_pan1.pos_x = menu_pos.x;
	menu_pan1.pos_y = menu_pos.y;
	menu_txt1.pos_x = menu_pos.x + menu_offs.x;
	menu_txt1.pos_y = menu_pos.y + menu_offs.y;
	menu_pan2.pos_x = menu_pan1.pos_x + menu_dist.x;
	menu_pan2.pos_y = menu_pan1.pos_y + menu_dist.y;
	menu_txt2.pos_x = menu_txt1.pos_x + menu_dist.x;
	menu_txt2.pos_y = menu_txt1.pos_y + menu_dist.y;
	menu_pan3.pos_x = menu_pan2.pos_x + menu_dist.x;
	menu_pan3.pos_y = menu_pan2.pos_y + menu_dist.y;
	menu_txt3.pos_x = menu_txt2.pos_x + menu_dist.x;
	menu_txt3.pos_y = menu_txt2.pos_y + menu_dist.y;
	menu_pan4.pos_x = menu_pan3.pos_x + menu_dist.x;
	menu_pan4.pos_y = menu_pan3.pos_y + menu_dist.y;
	menu_txt4.pos_x = menu_txt3.pos_x + menu_dist.x;
	menu_txt4.pos_y = menu_txt3.pos_y + menu_dist.y;
	menu_pan5.pos_x = menu_pan4.pos_x + menu_dist.x;
	menu_pan5.pos_y = menu_pan4.pos_y + menu_dist.y;
	menu_txt5.pos_x = menu_txt4.pos_x + menu_dist.x;
	menu_txt5.pos_y = menu_txt4.pos_y + menu_dist.y;
	menu_pan6.pos_x = menu_pan5.pos_x + menu_dist.x;
	menu_pan6.pos_y = menu_pan5.pos_y + menu_dist.y;
	menu_txt6.pos_x = menu_txt5.pos_x + menu_dist.x;
	menu_txt6.pos_y = menu_txt5.pos_y + menu_dist.y;
	menu_pan7.pos_x = menu_pan6.pos_x + menu_dist.x;
	menu_pan7.pos_y = menu_pan6.pos_y + menu_dist.y;
	menu_txt7.pos_x = menu_txt6.pos_x + menu_dist.x;
	menu_txt7.pos_y = menu_txt6.pos_y + menu_dist.y;

	// Now save the old actions of ESC, Cursor, ENTER keys into pointers
	// and assign them them new actions required for the menu
	old_menu_esc = on_esc;
	on_esc = _menu_clear;	// now ESC clears the menu
	old_cuu = on_cuu;
	on_cuu = _menu_up;		// CUU moves the selection cursor up
	old_cud = on_cud;
	on_cud = _menu_down;	// CUD moves it down
	old_menu_enter = on_enter;
	on_enter = _menu_exec;// and ENTER ececutes the selected item

	// and now place the menu cursor to the first item, and make the
	// whole menu visible.
	_menu_visible();
	_menu_set();	// highlight first item
}

///////////////////////////////////////////////////////////////////////
// Yes/No Panel stuff
var yesno_active = 0;

// For saving and restoring the old key actions
action* old_y;
action* old_z;
action* old_n;

// Action to execute if YES is clicked on
action* yesno_do;
function _yes_exec() { _yesno_clear(); yesno_do(); }

// The yes/no panel consists of 2 buttons, not surprisingly
panel yesno_pan
{
	layer 12; bmap yesno_back; flags transparent,refresh;
	button YES_OFFS_X,YESNO_OFFS_Y,yesno_hi,yesno_low,yesno_hi,
		_yes_exec,null,_buttonclick;
	button NO_OFFS_X,YESNO_OFFS_Y,yesno_hi,yesno_low,yesno_hi,
		_yesno_clear,null,_buttonclick;
}

// Texts of the panel and the two buttons
text yesno_txt { layer 13; font menu_font; string empty_str; }
text yes_txt { layer 13; font menu_font; string yes_str; }
text no_txt { layer 13; font menu_font; string no_str; }

///////////////////////////////////////////////////////////////////////
// Initialzes the yesno panel
function yesno_show()
{
	_menu_clear();		// in case menu was switched on before
	_yesno_clear();	// remove last yesno

	// set the position of yesno panels and text
	yesno_pan.pos_x = yesno_pos.x;
	yesno_pan.pos_y = yesno_pos.y;
	yesno_txt.pos_x = yesno_pan.pos_x + yesno_offs.x;
	yesno_txt.pos_y = yesno_pan.pos_y + yesno_offs.y;
	yes_txt.pos_x = yesno_txt.pos_x + YES_OFFS_X;
	yes_txt.pos_y = yesno_txt.pos_y + YESNO_OFFS_Y;
	no_txt.pos_x = yesno_txt.pos_x + NO_OFFS_X;
	no_txt.pos_y = yes_txt.pos_y;

	// let everything appear on screen
	yesno_pan.visible = ON;
	yesno_txt.visible = ON;
	yes_txt.visible = ON;
	no_txt.visible = ON;

	// Save the old key actions, and set the reqired panel actions
	old_yesno_esc = on_esc;
	on_esc = _yesno_clear;
	old_n = on_n;
	on_n = _yesno_clear;
	old_yesno_enter = on_enter;
	on_enter = _yes_exec;
	old_y = on_y;
	on_y = _yes_exec;
	old_z = on_z;		// for German keyboard...
	on_z = _yes_exec;

	yesno_active = 1;
	freeze_mode = 1;		// freeze game
}

// let the yesno panel disappear
function _yesno_hide()
{
	yesno_pan.visible = OFF;
	yesno_txt.visible = OFF;
	yes_txt.visible = OFF;
	no_txt.visible = OFF;
}

// exit the yesno panel
function _yesno_clear()
{
	if (yesno_active)
	{
		_yesno_hide();
		freeze_mode = 0;		// unfreeze game
		// restore old key actions
		on_esc = old_yesno_esc;
		on_n = old_n;
		on_enter = old_yesno_enter;
		on_y = old_y;
		on_z = old_z;
		yesno_active = 0;
	}
}

///////////////////////////////////////////////////////////////////////
// Options sliders stuff
define SLIDER_LEN,70;

bmap slider_map,<white.pcx>,0,0,10,10;
bmap slider_bar,<black.pcx>,0,0,SLIDER_LEN,2;

var bar_val1 = SLIDER_LEN;
var bar_val2 = SLIDER_LEN; }
var bar_val3 = SLIDER_LEN; }
var slider_soundvol = 80;// 0, 100;
var slider_musicvol = 50;//, 0, 100;
var slider_resolution = 3;//, 1, 8;

panel option_pan
{
	layer 10;	flags refresh;
	hbar 4,8,SLIDER_LEN,slider_bar,1,bar_val1;	// just to draw a black line
	hslider 4,4,SLIDER_LEN,slider_map,0,100,slider_soundvol;

	hbar 4,28,SLIDER_LEN,slider_bar,1,bar_val2;
	hslider 4,24,SLIDER_LEN,slider_map,0,100,slider_musicvol;

	hbar 4,48,SLIDER_LEN,slider_bar,1,bar_val3;
	hslider 4,44,SLIDER_LEN,slider_map,1,8,slider_resolution;
}

string optionsound_str,"-  volume  +";
string optionmusic_str,"-  music   +";
string optionres_str,  "-  video   +";


// move the cursor one slider up
function _slider_up()
{
	if(mouse_mode != 0) { return; }
	_buttonclick();
	menu_cursor -= 1;
	if(menu_cursor < 1) { menu_cursor = 3; }
}

// move the cursor one slider down
function _slider_down()
{
	if(mouse_mode != 0) { return; }
	_buttonclick();
	menu_cursor += 1;
	if(menu_cursor > 3) { menu_cursor = 1; }
}

// move selected slider to right
function _slider_right()
{
	if(mouse_mode != 0) { return; }
	_buttonclick();
	if(menu_cursor == 1)
	{
		slider_soundvol += 10;
		if(slider_soundvol > 100) { slider_soundvol = 100; }
	}
	if(menu_cursor == 2)
	{
		slider_musicvol += 10;
		if(slider_musicvol > 100) { slider_musicvol = 100; }
	}
	if(menu_cursor == 3)
	{
		slider_resolution += 1;
		if(slider_resolution > 8) { slider_resolution = 8; }
	}
}

// move selected slider to left
function _slider_left()
{
	if(mouse_mode != 0) { return; }
	_buttonclick();
	if(menu_cursor == 1)
	{
		slider_soundvol -= 10;
		if(slider_soundvol < 0) { slider_soundvol = 0; }
	}
	if(menu_cursor == 2) {
		slider_musicvol -= 10;
		if(slider_musicvol < 0) { slider_musicvol = 0; }
	}
	if(menu_cursor == 3)
	{
		slider_resolution -= 1;
		if(slider_resolution < 1) { slider_resolution = 1; }
	}
}

function options_hide()
{
	if(slider_resolution != video_mode)
	{
		switch_video slider_resolution,0,0;
		slider_resolution = video_mode;
		_show_resolution();
	}
	freeze_mode = 0;
	option_pan.visible = OFF;
	menu_txt1.visible = OFF;
	menu_txt2.visible = OFF;
	menu_txt3.visible = OFF;
	on_esc = old_menu_esc;
	on_cuu = old_cuu;
	on_cud = old_cud;
	on_cul = old_cul;
	on_cur = old_cur;
}

// Yet to do: modularize a slider panel
function game_options()
{
	exclusive_global;
	freeze_mode = 1;
	option_pan.pos_x = menu_pos.x;
	option_pan.pos_y = menu_pos.y;
	menu_txt1.pos_x = menu_pos.x + 2;
	menu_txt1.pos_y = menu_pos.y + 15;
	menu_txt2.pos_x = menu_txt1.pos_x;
	menu_txt2.pos_y = menu_txt1.pos_y + 20;
	menu_txt3.pos_x = menu_txt2.pos_x;
	menu_txt3.pos_y = menu_txt2.pos_y + 20;
	option_pan.visible = ON;
	menu_txt1.visible = ON;
	menu_txt2.visible = ON;
	menu_txt3.visible = ON;
	menu_txt1.string = optionsound_str;
	menu_txt2.string = optionmusic_str;
	menu_txt3.string = optionres_str;
	old_menu_esc = on_esc;
	on_esc = options_hide;
	old_cuu = on_cuu;
	on_cuu = _slider_up;
	old_cud = on_cud;
	on_cud = _slider_down;
	old_cul = on_cul;
	on_cul = _slider_left;
	old_cur = on_cur;
	on_cur = _slider_right;

	menu_cursor = 1;
	slider_soundvol = sound_vol;
	slider_musicvol = midi_vol;
	slider_resolution = video_mode;

	while(option_pan.visible == ON)
	{
		if(mouse_mode == 0)
		{
			if(menu_cursor == 1)
			{
				if(bar_val1 == 0)
				{
					bar_val1 = SLIDER_LEN;
				}
				else
				{
					bar_val1 = 0;
				}
				bar_val2 = SLIDER_LEN;
				bar_val3 = SLIDER_LEN;
			}
			if(menu_cursor == 2)
			{
				if(bar_val2 == 0)
				{
					bar_val2 = SLIDER_LEN;
				}
				else
				{
					bar_val2 = 0;
				}
				bar_val1 = SLIDER_LEN;
				bar_val3 = SLIDER_LEN;
			}
			if(menu_cursor == 3)
			{
				if(bar_val3 == 0)
				{
					bar_val3 = SLIDER_LEN;
				}
				else
				{
					bar_val3 = 0;
				}
				bar_val2 = SLIDER_LEN;
				bar_val1 = SLIDER_LEN;
			}
		}
		else
		{
		 	bar_val1 = SLIDER_LEN;
		 	bar_val2 = SLIDER_LEN;
		 	bar_val3 = SLIDER_LEN;
		}
		sound_vol = slider_soundvol;
		midi_vol = slider_musicvol;
		wait(1);
	}
}

///////////////////////////////////////////////////////////////////////
// save/load stuff
var slot	= 0; 	// number of last score
function _menu_save1() { slot = 1; mystring = name1_str; _game_save(); }
function _menu_save2() { slot = 2; mystring = name2_str; _game_save(); }
function _menu_save3() { slot = 3; mystring = name3_str; _game_save(); }
function _menu_save4() { slot = 4; mystring = name4_str; _game_save(); }
function _menu_save5() { slot = 5; mystring = name5_str; _game_save(); }

function _menu_save()
{
	menu_txt1.string = name1_str;
	menu_txt2.string = name2_str;
	menu_txt3.string = name3_str;
	menu_txt4.string = name4_str;
	menu_txt5.string = name5_str;
	menu_txt6.string = resume_str;

	menu_do1 = _menu_save1;
	menu_do2 = _menu_save2;
	menu_do3 = _menu_save3;
	menu_do4 = _menu_save4;
	menu_do5 = _menu_save5;
	menu_do6 = _menu_clear;

	menu_max = 6;
	menu_show();
}


function load_status()
{
	wait(2);	// don't override previous LOAD etc.
	load_info INFO_NAME,0;
}

function _game_save()
{
	_menu_visible();	// was hidden before
	inkey	mystring;
	if(result != 13) { _menu_clear(); return; }
	_menu_clear();
	save_status();			// save global skills & strings
	on_load = load_status;	// to automatically reload them

//	msg.STRING = wait_str;
//	show_message();

	save(SAVE_NAME,slot);	// save game
	if(result < 0)
	{		// Error?
		msg.string = save_error;
	}
	else
	{
		msg.string = ok_str;
	}
	show_message();
}


// after re-loading a game, reload all global parameters
function save_status()
{
	save_info(INFO_NAME,0);
}

///////////////////////////////////////////////////////////////////////
function help_hide()
{
	freeze_mode = 0;
	msg.visible = OFF;
	on_esc = old_help_esc;
	on_f1 = old_f1;
}

function game_help()
{
	freeze_mode = 1;
	msg.string = helptxt_str;
	msg.visible = ON;
	old_help_esc = on_esc;
	on_esc = help_hide;
	old_f1 = on_f1;
	on_f1 = help_hide;
}

///////////////////////////////////////////////////////////////////////
// menu actions for a standard game

function _menu_load1() { slot = 1; _game_load(); }
function _menu_load2() { slot = 2; _game_load(); }
function _menu_load3() { slot = 3; _game_load(); }
function _menu_load4() { slot = 4; _game_load(); }
function _menu_load5() { slot = 5; _game_load(); }

function _menu_load()
{
	menu_txt1.string = name1_str;
	menu_txt2.string = name2_str;
	menu_txt3.string = name3_str;
	menu_txt4.string = name4_str;
	menu_txt5.string = name5_str;
	menu_txt6.string = resume_str;

	menu_do1 = _menu_load1;
	menu_do2 = _menu_load2;
	menu_do3 = _menu_load3;
	menu_do4 = _menu_load4;
	menu_do5 = _menu_load5;
	menu_do6 = _menu_clear;

	menu_max = 6;
	menu_show();
}

function game_exit()
{
	save_status();			// save global skills & strings
	exit	"3D GameStudio (c) conitec 2001\n";
}

function exit_yesno()
{
	yesno_txt.string = quit_yesno;
	yesno_do = game_exit;
	yesno_show();
}

// Desc: default action, to be replaced by a game-adapted action
function game_init()
{
	key_init();
	weapon_init();
	main();
}

// dummy actions, if weapons.wdl or doors.wdl are not included
function weapon_init() { return; }
function key_init() { return; }

function menu_main()
{
	menu_txt1.string = new_game_str;
	menu_txt2.string = load_game_str;
	menu_txt3.string = save_game_str;
	menu_txt4.string = quit_game_str;
	menu_txt5.string = options_str;
	menu_txt6.string = help_str;
	menu_txt7.string = resume_str;

	menu_do1 = game_init;	// normally an action which resets all
	menu_do2 = _menu_load;
	menu_do3 = _menu_save;
	menu_do4 = exit_yesno;
	menu_do5 = game_options;
	menu_do6 = game_help;
	menu_do7 = _menu_clear;

	menu_max = 7;
	menu_show();
}

var_info _entry = 0; // { TYPE GLOBAL; VAL 0; }
function game_entry()
{	// mark the score to re-enter the game (yet to do)
	if(_entry == 0)
	{
		_entry = 1;
	}
}


///////////////////////////////////////////////////////////////////////
function _game_load()
{
	msg.string = wait_str;
	show_message();
	wait(1);				// to display wait message before loading

	load(SAVE_NAME,slot);
	msg.string = load_error;	// failed!
	show_message();
}

///////////////////////////////////////////////////////////////////////////////////
// Desc: switches the mouse on and off
function mouse_toggle()
{
	mouse_mode += 2;
	if(mouse_mode > 2)
	{	// was it already on?
		mouse_mode = 0;		// mouse off
	}
	else
	{
		mouse_on();
	}
}

// Desc: switches the mouse on
function mouse_on()
{
	menu_select.visible = OFF;	// menu now handled by mouse
	mouse_map = arrow;
	while(mouse_mode > 0)
	{
		mouse_pos.x = pointer.x;
		mouse_pos.y = pointer.y;
		wait(1); 		      // now move it over the screen
	}
}

// Desc: switches the mouse off
function mouse_off()
{
	mouse_mode = 0;
}

//var MOUSE_SPOT[2] = 5,5;

////////////////////////////////////////////////////////////////////////////
// For debugging purposes, use the EXECUTE instruction
// to type in WDL instructions during gameplay, like at a console.
// You can examine skill values through "TO_STRING look,skill;"

string exec_buffer	// just an 80-char string
"                                                                              ";
string look "         "; // to see skills via TO_STRING;

text console_txt
{
	pos_x 4;
	layer	10;
	font 	standard_font;
	strings 3;
ifdef CONSOLE_MODE_2;
	string "Enter instructions below, abort with [ESC]:";
ifelse;
	string "Enter instructions below:";
endif;
	string exec_buffer;
	string look;
}

function console()
{
	if(console_txt.visible == ON) { return; }	//already running
	console_txt.pos_y = screen_size.y - 60;
	console_txt.visible = ON;
	while(console_txt.visible == ON)
	{
		inkey	exec_buffer;
		if(result == 13)
		{
			execute exec_buffer;
ifdef CONSOLE_MODE_2;
		}
		else
		{
			console_txt.visible = OFF;
		}
ifelse;
		}
		console_txt.visible = OFF;
endif;
	}
}

// Implementing a scrolling console, instead of a 1-line one,
// is left as an exercise to the reader...

//////////////////////////////////////////////////////////////
// screen resolution display
//////////////////////////////////////////////////////////////////////
string resolution_str,"                              ";
string screen_str,"Video ";
string x_str,"x";

// Mod Date: 11/1/00 DCP
//		Replaced to_string, add_string, and set_string with
//	str_for_num, str_cat, and str_cpy
function _show_resolution()
{
	// compose the resolution string from strings and numbers
	str_cpy(resolution_str,screen_str);

	// now it reads "Video "
	str_for_num(temp_str,screen_size.x);
	str_cat(resolution_str,temp_str);
	// now it reads "Video hhhh" (hhhh is the hor resolution)
	str_cat(resolution_str,x_str);
	// now it reads "Video hhhhx"
	str_for_num(temp_str,screen_size.y);
	str_cat(resolution_str,temp_str);
	// now it reads "Video hhhhxvvvv"
	str_cat(resolution_str,x_str);
	// now it reads "Video hhhhxvvvvx"
	str_for_num(temp_str,video_depth);
	str_cat(resolution_str,temp_str);
	// and now it reads "Video hhhhxvvvvxdd"

	msg.string = resolution_str;
	show_message();
}

function game_resolution()
{
	_toggle_video();
	_show_resolution();
}

//////////////////////////////////////////////////////////////////////
// Default key assignements to control the game
//on_esc menu_main;
//on_f1	 game_help;
//on_f5	 game_resolution;
//on_f10 exit_yesno;
on_tab console;

on_mouse_right	mouse_toggle;